nodejs中的异常错误处理

异常处理是程序运行中必须要关注的地方,当异常出现后,应该第一时间关注到,并且快速解决。大部分程序员们都不敢保证自己的代码百分比正确,所以应该在写代码时就要对异常提前做预防处理,尽量保证在异常出现时,给用户一个友好的提示,不至于服务挂起导致请求超时,并且能将异常信息做记录上报,方便后期排查解决。

一. 同步代码的异常捕获处理

1. 同步代码中的异常使用try{}catch结构即可捕获处理。

try {
  throw new Error('错误信息');
} catch (e) {
  console.error(e.message);
}

可以正常捕获到。

二. 异步代码的错误处理

1. try/catch 接口

异步代码下使用try{}catch结构捕获处理效果如何呢?

try {
  setTimeout(()=>{
    throw new Error('错误信息');
  })
} catch (e) {
  console.error('error is:', e.message);
}

执行结果:

然而却没有捕获到异步错误。

2. process的uncaughtException事件

那异步错误该怎么处理呢?首先换个思维,因为异常并不是事先准备好的,不能控制其到底在哪儿发生,所以站更高的角度,如监听应用进程的错误异常,从而捕获不能预料的错误异常,保证应用不至于崩溃。

process.on('uncaughtException', (e)=>{
  console.error('process error is:', e.message);
});

如上代码从process上监听uncaughtException事件,可以捕获到整个进程包含异步中的错误信息,从而保证应用没有奔溃。

但是新的问题随之而来,因为异常不可预料的发生后,当异常出现时,直接从对应执行栈中断,而到process捕获的异常事件下,导致了v8引擎的垃圾回收功能不能按照正常流程工作,然后开始出现内存泄漏问题。

相对于异常来说,内存泄漏也是一个不能忽视的严重问题,而process.on('uncaughtException')的做法,很难去保证不造成内存的泄漏。所以当捕获到异常时,显式的手动杀掉进程,并开始重启node进程,即保证释放内存,又保证了保证服务后续正常可用。

process.on('uncaughtException', (e)=>{
  console.error('process error is:', e.message);
  process.exit(1);
  restartServer(); // 重启服务
});

但是上面的做法有一点直接,大家不免存疑惑,如果单进程单实例的部署下,杀掉进程在重启这一段时间内服务不能正常可用怎么办?这显然是不合理的。

3. 使用domain模块

domain模块,把处理多个不同的IO的操作作为一个组。注册事件和回调到domain,当发生一个错误事件或抛出一个错误时,domain对象会被通知,不会丢失上下文环境,也不导致程序错误立即退出,与process.on('uncaughtException')不同。

Domain 模块可分为隐式绑定和显式绑定: 隐式绑定: 把在domain上下文中定义的变量,自动绑定到domain对象 显式绑定: 把不是在domain上下文中定义的变量,以代码的方式绑定到domain对象

const domain = require('domain');
const d = domain.create();

d.on('error', (err) => {
  console.log('err', err.message);
  console.log(needSend.message);
});

const needSend = { message: '需要传递给错误处理的一些信息' };
d.add(needSend);

function excute() {
  try {
    setTimeout(()=>{
      throw new Error('错误信息');
    });
  } catch (e) {
    console.error('error is:', e.message);
  }
};

d.run(excute);

domin明显的优点,能把出问题时的一些信息传递给错误处理函数,可以做一些打点上报等处理工作,最起码保证重启后的服务,程序猿们知道发生了什么,有线索可查,也可以选择传递上下文进去,做一些后续处理。比如当服务出错的时候,可以把用户请求栈信息传给下游,返回告知用户服务异常,而不是用户一直等到请求自动超时。

...
d.add(res);
...
d.on('error', (err) => {
  console.log('err', err.message);
  res.end('服务器发生异常,请稍后再试!');
});

但是它和process.on('uncaughtException')的做法一样,很难去保证不造成内存的泄漏。

另外在官方文档上,domain模块处理废弃状态,但是现在也没有其他方案可以完全代替domain模块,但是我现在node10的版本依旧可以用,暂时应该不用担心domain模块被废弃的问题。

三. 多进程模式加异常捕获后重启

上面的方式没有完美解决问题,思考一下如何能够让异常发生后不奔溃,捕获异常后不造成内存泄漏,而且重启释放缓存不造成服务不可用呢?

一种比较好的方案是,以多进程(cluster)的模式去部署应用,当某一个进程被异常捕获后,可以做一下打点上报后,开始重启释放内存,此时其他请求被接受后,其他进程依旧可以对外提供服务,当然前提是你的应用不能异常多的数都数不清。

下面是将cluster和domain结合起来使用,以多进程的方式保证服务可用,同时可以将错误信息传递下去进行上报,并且保留错误出现的上下文环境,给用户返回请求,不让用户请求超时,然后在手动杀死异常进程,然后重启。

const cluster = require('cluster');
const os = require('os');
const http = require('http');
const domain = require('domain');

const d = domain.create();

if (cluster.isMaster) {
  const cpuNum = os.cpus().length;
  for (let i = 0; i < cpuNum; ++i) {
    cluster.fork()
  };
  // fork work log
  cluster.on('fork', worker=>{
    console.info(`${new Date()} worker${worker.process.pid}进程启动成功`);
  });
  // 监听异常退出进程,并重新fork
  cluster.on('exit',(worker,code,signal)=>{
    console.info(`${new Date()} worker${worker.process.pid}进程启动异常退出`);
    cluster.fork();
  })
} else {
  http.createServer((req, res)=>{
    d.add(res);
    d.on('error', (err) => {
      console.log('记录的err信息', err.message);
      console.log('出错的 work id:', process.pid);
      // uploadError(err)  // 上报错误信息至监控
      res.end('服务器异常, 请稍后再试');
      // 将异常子进程杀死
      cluster.worker.kill(process.pid);
    });
    d.run(handle.bind(null, req, res));
  }).listen(8080);
}

function handle(req, res) {
  if (process.pid % 2 === 0) {
    throw new Error(`出错了`);
  }
  res.end(`response by worker: ${process.pid}`);
};

本文分享自微信公众号 - code秘密花园(code_mmhy)

原文出处及转载信息见文内详细说明,如有侵权,请联系 yunjia_community@tencent.com 删除。

原始发表时间:2019-07-09

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

发表于

我来说两句

0 条评论
登录 后参与评论

扫码关注云+社区

领取腾讯云代金券